/* Copyright 2004, 2005 Lei Zhang, Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <tchar.h>
#include <string.h>
#include <winsock2.h>
#include "TSEvents.h"

//FIXME: Do I need to make these operations be mutual exclusive?

EventSocketList eventSocketList;
PEventSocketList pEventSocketList = &eventSocketList;

BOOL InitEventSocketList(/*PEventSocketList pEventSocketList*/)
{
	int i;
	for (i = 0; i < MAX_EVENT; i++)
	{
		pEventSocketList->hEvents[i] = NULL;
		pEventSocketList->sockets[i] = 0;
		pEventSocketList->num = 0;
	}
	return TRUE;
}

BOOL AddSocket(/*PEventSocketList pEventSocketList,*/SOCKET sock)
{
	int idx = pEventSocketList->num;
	HANDLE hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	pEventSocketList->sockets[idx] = sock;
	pEventSocketList->hEvents[idx] = hEvent;
	//WSAEventSelect(sock, hEvent, FD_READ | FD_WRITE | FD_CONNECT | FD_ACCEPT | FD_CLOSE);
	WSAEventSelect(sock, pEventSocketList->hEvents[0], FD_READ | FD_WRITE | FD_CONNECT | FD_ACCEPT | FD_CLOSE);
	pEventSocketList->num++;
	return TRUE;
}

BOOL RemoveSocket(/*PEventSocketList pEventSocketList,*/ SOCKET sock)
{
	int idx = -1, i;
	for (i = 0; i < pEventSocketList->num; i++)
	{
		if (sock == pEventSocketList->sockets[i])
		{
			idx = i;
			break;
		}
	}
	if (idx == -1)
	{
		return FALSE;
	}
	else
	{   
		CloseHandle(pEventSocketList->hEvents[idx]);
		pEventSocketList->hEvents[idx] = pEventSocketList->hEvents[pEventSocketList->num-1];
		pEventSocketList->sockets[idx] = pEventSocketList->sockets[pEventSocketList->num-1];
		pEventSocketList->num--;
	}
	return TRUE;
}

BOOL AddEvent(/*PEventSocketList pEventSocketList,*/ HANDLE hEvent)
{
	int idx = pEventSocketList->num;
	pEventSocketList->sockets[idx] = -1;
	pEventSocketList->hEvents[idx] = hEvent;
	pEventSocketList->num++;
	return TRUE;
}

BOOL RemoveEvent(/*PEventSocketList pEventSocketList,*/ HANDLE hEvent)
{
	int idx = -1, i;
	for (i = 0; i < pEventSocketList->num; i++)
	{
		if (hEvent == pEventSocketList->hEvents[i])
		{
			idx = i;
			break;
		}
	}
	if (idx == -1)
	{
		return FALSE;
	}
	else
	{   
		pEventSocketList->hEvents[idx] = pEventSocketList->hEvents[pEventSocketList->num-1];
		pEventSocketList->sockets[idx] = pEventSocketList->sockets[pEventSocketList->num-1];
		pEventSocketList->num--;
	}
	return TRUE;
}

