/*
 *
 * Common definitions for all of thinc
 *
 * Author:
 * Ricardo Baratto
 * Network Computing Lab - Columbia University
 *
 */

/* set tabstop = 8 */

/* Return values
 * All functions should use these return values. If you need different, 
 * or yours have different meaning, define and document them here. Don't 
 * just use literal numbers or i'll hunt you down */
#define T_OK	1
#define T_ERROR	-1

#define T_TRUE	1
#define T_FALSE 0
#define T_YES 	T_TRUE
#define T_NO 	T_FALSE

/* server defined return values */
#define T_CLOSED 	0
#define T_WOULDBLOCK	-2
#define T_TIMEOUT 	-3

#define T_STOP		2	/* stops execution of a message */

/*
#define T_YIELD	0	/ * command flushed partially due to yield() * /
 */
#define T_DONE	1	/* command flushed completely */
#define T_PART	2	/* command flushed only partially (due to network
			   full, not yield of the CPU) */

#define T_CLIPPED 0	/* command is empty as a result of a modification */
#define T_MERGED 2	/* command was merged while trying to queue it */
#define T_COPIED 2	/* command had to be copied anyway (thincBufferCmd) */
