/*
 * thincProtoSound.h
 *
 * Client/server sound protocol definition for THINC
 *
 * Author: Leo Kim (lnk2101@cs.columbia.edu)
 * Network Computing Lab - Columbia University
 */

/* set tabstop = 8 */
#ifndef _THINC_PROTO_SOUND_H_
#define _THINC_PROTO_SOUND_H_

/* Message type */
#define T_SND_DATA			70
#define T_SND_OPEN			71
#define T_SND_PLAY			72
#define T_SND_CLOSE			73
#define T_SND_VOLUME_DOWN	74
#define T_SND_VOLUME_UP		75

/* Data structures */
/* Tells the client to open its sound card and defines the format of the sound
 * stream. */
typedef struct thinc_sndOpen_s {
	/* for synchronization */
    int rate        :16;
    int bits        :8;
    int channels    :8;
    int endian      :8;
    char pad[3];
} thinc_sndOpen;
#define T_SND_OPEN_SIZE   5

/* support up to 256 (!) streams */
typedef struct thinc_sndPlay_s {
    int size 		:32;
	int timestamp	:32;
	int id			:8;
	char pad[3];
} thinc_sndPlay;
#define T_SND_PLAY_SIZE   9

typedef struct thinc_sndClose_s {
	/* Tell which ID to close.*/
	int id			:8;
	char pad[3];
} thinc_sndClose;
#define T_SND_CLOSE_SIZE   1

#endif	/* _THINC_PROTO_SOUND_H */
