/*
 * $Id; $
 *
 * SSL library API for THINC
 *
 * Author:
 * Angelos Stavrou <angel@cs.columbia.edu>
 * Stelianos Sidiroglou-Douskos <stelios@cs.columbia.edu>
 * Department of Computer Science - Columbia University
 *
 * Modified for THINC:
 * Ricardo Baratto
 * Network Computing Lab - Columbia University
 */

/* set tabstop = 8 */

/* TODO: Can't use printf or ERR_ or ... */

#ifndef _THINC_SSL_H_
#define _THINC_SSL_H_

#define OPENSSL_NO_KRB5

#ifdef T_WIN32
#include "openssl\\ssl.h"
#else
#include <openssl/ssl.h>
#include <openssl/err.h>
#endif

/* return values */
#define T_SSL_OK		 1
#define T_SSL_ERROR		-1
#define T_SSL_WOULDBLOCK	-2
#define T_SSL_CLOSED		0

/** Client **/
/*
 * Opens an SSL connection using the socket sock
 * Returns 1 on success, -1 on error.
 * May not work with non-blocking sockets. sorry, i'm lazy :)
 */
int thinc_ssl_connect(int sock, const char *cert_location, SSL **ssl_p);

/** Server **/
SSL_CTX* thinc_ssl_init_server(const char *cert_location, 
	const char *key_location);
/* like accept(). *ssl_p may be destroyed if something fails (it'll be set 
 * to NULL). Basically, it assumes that if *ssl_p != NULL, then you called
 * us at least once before */
int thinc_ssl_accept(int client, SSL_CTX *ctx, SSL **ssl_p);

/** I/0 **/
int thinc_ssl_write(SSL *ssl, const void *buf, int count);
int thinc_ssl_read(SSL *ssl, void *buf, int count);

#endif
