/* Copyright 2004, 2005 Lei Zhang, Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/******************************Module*Header*******************************\
*
*                           *******************
*                           * GDI SAMPLE CODE *
*                           *******************
*
* Module Name: enable.c
*
* This module contains the functions that enable and disable the
* driver, the pdev, and the surface.
*
* Copyright (c) 1992-1998 Microsoft Corporation
\**************************************************************************/
#define COPYBITS_DBG_LEV 2

#include "driver.h"
#include "MirrCmdProto.h"
#include "rops.h"

/* refer to \mirror\disp\enable.c@line: 18 */

/* refer to \mirror\disp\enable.c@line: 20 */
/* refer to \mirror\disp\enable.c@line: 21 */
/* refer to \mirror\disp\enable.c@line: 22 */
/* refer to \mirror\disp\enable.c@line: 23 */
/* refer to \mirror\disp\enable.c@line: 24 */
/* refer to \mirror\disp\enable.c@line: 25 */
/* refer to \mirror\disp\enable.c@line: 26 */
/* refer to \mirror\disp\enable.c@line: 27 */
#if 1
/* refer to \mirror\disp\enable.c@line: 29 */
/* refer to \mirror\disp\enable.c@line: 30 */
/* refer to \mirror\disp\enable.c@line: 31 */
/* refer to \mirror\disp\enable.c@line: 32 */
/* refer to \mirror\disp\enable.c@line: 33 */
/* refer to \mirror\disp\enable.c@line: 34 */
/* refer to \mirror\disp\enable.c@line: 35 */
/* refer to \mirror\disp\enable.c@line: 36 */
/* refer to \mirror\disp\enable.c@line: 37 */
/* refer to \mirror\disp\enable.c@line: 38 */
	// THINC
	{	INDEX_DrvEscape,				(PFN) DrvEscape				},
	//
	{	INDEX_DrvAlphaBlend,			(PFN) DrvAlphaBlend			},
	{	INDEX_DrvFillPath,				(PFN) DrvFillPath			},
	{	INDEX_DrvGradientFill,			(PFN) DrvGradientFill		},
	{	INDEX_DrvLineTo,				(PFN) DrvLineTo				},
	{	INDEX_DrvPlgBlt,				(PFN) DrvPlgBlt				},
	{	INDEX_DrvStretchBlt,			(PFN) DrvStretchBlt			},
	{	INDEX_DrvStretchBltROP,			(PFN) DrvStretchBltROP		},
	{	INDEX_DrvStrokeAndFillPath,		(PFN) DrvStrokeAndFillPath	},
	{	INDEX_DrvTransparentBlt,		(PFN) DrvTransparentBlt		},
	{	INDEX_DrvSetPointerShape,		(PFN) DrvSetPointerShape	},
	{	INDEX_DrvMovePointer,			(PFN) DrvMovePointer		}
};

//
/* refer to \mirror\disp\enable.c@line: 42 */
/* refer to \mirror\disp\enable.c@line: 43 */
//

#define flGlobalHooks   HOOK_BITBLT|HOOK_TEXTOUT|HOOK_COPYBITS|HOOK_STROKEPATH\
	|HOOK_ALPHABLEND/*|HOOK_FILLPATH*/|HOOK_GRADIENTFILL|HOOK_LINETO/*|HOOK_PLGBLT*/\
	|HOOK_STRETCHBLT/*|HOOK_STRETCHBLTROP|HOOK_STROKEANDFILLPATH*/|HOOK_TRANSPARENTBLT\
	//|HOOK_SETPOINTERSHAPE|HOOK_MOVEPOINTER

// AlphaBlend is for some internal icons
// gradientFill is for the windows title
//Define the functions you want to hook for 8/16/24/32 pel formats

/* refer to \mirror\disp\enable.c@line: 50 */

/* refer to \mirror\disp\enable.c@line: 52 */

/* refer to \mirror\disp\enable.c@line: 54 */

/* refer to \mirror\disp\enable.c@line: 56 */

#define PPDEV_OF_PSURFOBJ(surf) ((PPDEV)((surf)->dhpdev))
#define MKTAG(STR) (*(ULONG*)(&(STR)))

PCWSTR  enNewCmd			= L"\\BaseNamedObjects\\THINCNewCommand";
PCWSTR  enBlockOnDraw		= L"\\BaseNamedObjects\\THINCBlockOnDraw";
PCWSTR  enRestart			= L"\\BaseNamedObjects\\THINCRestart";
PCWSTR	enStartBlocking		= L"\\BaseNamedObjects\\THINCStartBlocking";
PCWSTR	enBlockOnCopy		= L"\\BaseNamedObjects\\THINCBlockOnCopy";
PCWSTR	enStartBlockingCopy	= L"\\BaseNamedObjects\\THINCStartBlockingCopy";

/* Parameters for blocking drawing*/
int recheckInterval;
int maxCount;

/******************************Public*Routine******************************\
* DrvEnableDriver
*
* Enables the driver by retrieving the drivers function table and version.
*
\**************************************************************************/

/* refer to \mirror\disp\enable.c@line: 65 */
/* refer to \mirror\disp\enable.c@line: 66 */
/* refer to \mirror\disp\enable.c@line: 67 */
/* refer to \mirror\disp\enable.c@line: 68 */
/* refer to \mirror\disp\enable.c@line: 69 */
/* refer to \mirror\disp\enable.c@line: 70 */
/* refer to \mirror\disp\enable.c@line: 71 */
/* refer to \mirror\disp\enable.c@line: 72 */
/* refer to \mirror\disp\enable.c@line: 73 */

/* refer to \mirror\disp\enable.c@line: 75 */

/* refer to \mirror\disp\enable.c@line: 77 */
	
/* refer to \mirror\disp\enable.c@line: 79 */

/* refer to \mirror\disp\enable.c@line: 81 */
/* refer to \mirror\disp\enable.c@line: 82 */

/* refer to \mirror\disp\enable.c@line: 84 */
/* refer to \mirror\disp\enable.c@line: 85 */

/* refer to \mirror\disp\enable.c@line: 87 */
/* refer to \mirror\disp\enable.c@line: 88 */

/* refer to \mirror\disp\enable.c@line: 90 */
/* refer to \mirror\disp\enable.c@line: 91 */
/* refer to \mirror\disp\enable.c@line: 92 */
/* refer to \mirror\disp\enable.c@line: 93 */

/* refer to \mirror\disp\enable.c@line: 95 */
/* refer to \mirror\disp\enable.c@line: 96 */

#define LoadFunctionPointerFromDll(ppdev, pf, funcName, errExit)	\
{																					\
	PVOID (ppdev)->pf = EngFindImageProcAddress((ppdev)->hMemDll, (funcName));		\
	if (pf == NULL)																	\
	{																				\
		DISPDBG((0, " DrvEnablePDEV: Fail to find % function in mem.dll\n", (funcName)));\
		goto (errExit);																\
	}																				\
}																					\

/******************************Public*Routine******************************\
* DrvEnablePDEV
*
* DDI function, Enables the Physical Device.
*
* Return Value: device handle to pdev.
*
\**************************************************************************/

/* refer to \mirror\disp\enable.c@line: 107 */
/* refer to \mirror\disp\enable.c@line: 108 */       // Pointer to DEVMODE
/* refer to \mirror\disp\enable.c@line: 109 */ // Logical address
/* refer to \mirror\disp\enable.c@line: 110 */      // number of patterns
/* refer to \mirror\disp\enable.c@line: 111 */ // return standard patterns
/* refer to \mirror\disp\enable.c@line: 112 */      // Length of memory pointed to by pGdiInfo
/* refer to \mirror\disp\enable.c@line: 113 */       // Pointer to GdiInfo structure
/* refer to \mirror\disp\enable.c@line: 114 */      // Length of following PDEVINFO structure
/* refer to \mirror\disp\enable.c@line: 115 */       // physical device information structure
/* refer to \mirror\disp\enable.c@line: 116 */           // HDEV, used for callbacks
/* refer to \mirror\disp\enable.c@line: 117 */ // DeviceName - not used
/* refer to \mirror\disp\enable.c@line: 118 */        // Handle to base driver
/* refer to \mirror\disp\enable.c@line: 119 */
/* refer to \mirror\disp\enable.c@line: 120 */
/* refer to \mirror\disp\enable.c@line: 121 */
	INT		i;
/* refer to \mirror\disp\enable.c@line: 122 */

/* refer to \mirror\disp\enable.c@line: 124 */

/* refer to \mirror\disp\enable.c@line: 126 */
/* refer to \mirror\disp\enable.c@line: 127 */

/* refer to \mirror\disp\enable.c@line: 129 */

    ppdev = (PPDEV) EngAllocMem(FL_NONPAGED_MEMORY | FL_ZERO_MEMORY, sizeof(PDEV), ALLOC_TAG);

/* refer to \mirror\disp\enable.c@line: 133 */
/* refer to \mirror\disp\enable.c@line: 134 */
/* refer to \mirror\disp\enable.c@line: 135 */
/* refer to \mirror\disp\enable.c@line: 136 */
/* refer to \mirror\disp\enable.c@line: 137 */

/* refer to \mirror\disp\enable.c@line: 139 */

/* refer to \mirror\disp\enable.c@line: 141 */

/* refer to \mirror\disp\enable.c@line: 143 */

/* refer to \mirror\disp\enable.c@line: 145 */

/* refer to \mirror\disp\enable.c@line: 147 */
/* refer to \mirror\disp\enable.c@line: 148 */
/* refer to \mirror\disp\enable.c@line: 149 */
        goto error_free_0;
    }
    
/* refer to \mirror\disp\enable.c@line: 153 */

/* refer to \mirror\disp\enable.c@line: 155 */

/* refer to \mirror\disp\enable.c@line: 157 */
/* refer to \mirror\disp\enable.c@line: 158 */

/* refer to \mirror\disp\enable.c@line: 160 */


	// THINC
	ppdev->drvManagedCursor = FALSE;

	//
	// Intialize the command block
	//
	if ((ppdev->pCmdBlock = thincCmdBlockCreateMax()) == NULL)
	{
		DISPDBG((0, "DrvEnablePDEV: failed in thincCmdBlockCreateMax()\n"));
		goto error_free_0;
	}
                                  
	//
	// Initialize the command queue
	//
	if (thincCreateCmdQueue(&(ppdev->pCmdPtrQueue)) <= 0)
	{
		DISPDBG((0, "DrvEnablePDEV: failed in thincCreateCmdQueue()\n"));
		goto error_free_1;
	}
    
	//
	// Load dll which is for memory mapping
	//
	ppdev->hMemDll = EngLoadImage(L"mem.dll");
	if (ppdev->hMemDll == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to load mem.dll\n"));
		goto error_free_queue;
	}
	
	//LoadFunctionPointerFromDll(ppdev, pfCreateMem, "CreateMem", error_free_queue);
	ppdev->pfCreateMem = EngFindImageProcAddress(ppdev->hMemDll, "CreateMem");
	if (ppdev->pfCreateMem == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to find CreateMem function in mem.dll\n"));
		goto error_free_queue;
	}																			 
	
	ppdev->pfDeAllocMem = EngFindImageProcAddress(ppdev->hMemDll, "DeAllocMem");
	if (ppdev->pfDeAllocMem == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to find DeAllocMem function in mem.dll\n"));
		goto error_free_queue;
	}

	ppdev->pfMapMem = EngFindImageProcAddress(ppdev->hMemDll, "MapMem");
	if (ppdev->pfMapMem == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to find MapMem function in mem.dll\n"));
		goto error_free_queue;
	}

	ppdev->pfUnMapMem = EngFindImageProcAddress(ppdev->hMemDll, "UnMapMem");
	if (ppdev->pfUnMapMem == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to find UnMapMem function in mem.dll\n"));
		goto error_free_queue;
	}

	ppdev->pfOpenEvent = EngFindImageProcAddress(ppdev->hMemDll, "OpenAndSetSharedEvent");
	if (ppdev->pfOpenEvent == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to find OpenAndSetSharedEvent function in mem.dll\n"));
		goto error_free_queue;
	}

	ppdev->pfSetEvent = EngFindImageProcAddress(ppdev->hMemDll, "SetSharedEvent");
	if (ppdev->pfOpenEvent == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to find SetSharedEvent function in mem.dll\n"));
		goto error_free_queue;
	}

	ppdev->pfResetEvent = EngFindImageProcAddress(ppdev->hMemDll, "ResetSharedEvent");
	if (ppdev->pfOpenEvent == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to find ResetSharedEvent function in mem.dll\n"));
		goto error_free_queue;
	}

	ppdev->pfQuerySystemTime = EngFindImageProcAddress(ppdev->hMemDll, "QuerySystemTime");
	if (ppdev->pfQuerySystemTime == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to find QuerySystemTime function in mem.dll\n"));
		goto error_free_queue;
	}

	ppdev->pfCloseEvent = EngFindImageProcAddress(ppdev->hMemDll, "CloseSharedEvent");
	if (ppdev->pfCloseEvent == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to find CloseSharedEvent function in mem.dll\n"));
		goto error_free_0;
	}

	ppdev->pfWaitOnEvent = EngFindImageProcAddress(ppdev->hMemDll, "WaitOnSharedEvent");
	if (ppdev->pfWaitOnEvent == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to find WaitOnSharedEvent function in mem.dll\n"));
		goto error_free_0;
	}

	ppdev->pfAtomicCompareExchange = 
		EngFindImageProcAddress(ppdev->hMemDll, "AtomicCompareExchange");
	if (ppdev->pfAtomicCompareExchange == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to find AtomicCompareExchange function in mem.dll\n"));
		goto error_free_0;
	}

/*
	if ((ppdev->pEventBlockOnDraw = ppdev->pfOpenEvent(enBlockOnDraw)) == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to create EventBlockOnDraw \n"));
		goto error_free_close_event_0;
	}

	if ((ppdev->pEventNewCmd = ppdev->pfOpenEvent(enNewCmd)) == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to create EventNewCmd \n"));
		goto error_free_close_event_1;
	}

	if ((ppdev->pEventStartBlocking = ppdev->pfOpenEvent(enStartBlocking)) == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to create EventStartBlocking \n"));
		goto error_free_close_event_2;
	}

	if ((ppdev->pEventBlockOnCopy = ppdev->pfOpenEvent(enBlockOnCopy)) == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to create EventBlockOnCopy \n"));
		goto error_free_close_event_3;
	}

	if ((ppdev->pEventRestart = ppdev->pfOpenEvent(enRestart)) == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to create EventRestart \n"));
		goto error_free_close_event_4;
	}

	if ((ppdev->pEventStartBlockingCopy = ppdev->pfOpenEvent(enStartBlockingCopy)) == NULL)
	{
		DISPDBG((0, " DrvEnablePDEV: Fail to create EventStartBlockingCopy \n"));
		goto error_free_close_event_5;
	}
*/

	//
	// Flags
	//
	ppdev->thincSignals.bReqBlockDrawing = FALSE;
	ppdev->thincSignals.bReqNewCommandSignal = FALSE;
	ppdev->thincSignals.bStatusBlockBeforeCopy = FALSE;
	ppdev->thincSignals.bStatusDrawing = FALSE;
	ppdev->thincSignals.bStatusWaitingForDrawingFinishes = FALSE;

	// The server is not on at this moment

	ppdev->bServerOn = FALSE;

	// Initial the drawing call stack depth counter

	ppdev->iCallStackDepth = 0;

	// offscreen Ids
	for (i = 0; i < MAX_OFF_SURF; i++)
	{
		ppdev->surfList[i] = NULL;
	}
	ppdev->lastOffScreenSurfId = MAX_OFF_SURF;

    //
	// Everything goes well.
	//
/* refer to \mirror\disp\enable.c@line: 163 */

/* refer to \mirror\disp\enable.c@line: 165 */
/*
error_free_close_event_5:
	ppdev->pfCloseEvent(ppdev->pEventRestart);
error_free_close_event_4:
	ppdev->pfCloseEvent(ppdev->pEventBlockOnCopy);
error_free_close_event_3:
	ppdev->pfCloseEvent(ppdev->pEventStartBlocking);
error_free_close_event_2:
	ppdev->pfCloseEvent(ppdev->pEventNewCmd);
error_free_close_event_1:
	ppdev->pfCloseEvent(ppdev->pEventBlockOnDraw);
error_free_close_event_0:
	EngUnloadImage(ppdev->hMemDll);
*/
error_free_queue:
	EngFreeMem(ppdev->pCmdPtrQueue);
error_free_1:
	EngFreeMem(ppdev->pCmdBlock);
error_free_0:
    EngFreeMem(ppdev);
/* refer to \mirror\disp\enable.c@line: 136 */
/* refer to \mirror\disp\enable.c@line: 137 */

/******************************Public*Routine******************************\
* DrvCompletePDEV
*
* Store the HPDEV, the engines handle for this PDEV, in the DHPDEV.
*
\**************************************************************************/

/* refer to \mirror\disp\enable.c@line: 178 */
/* refer to \mirror\disp\enable.c@line: 179 */
/* refer to \mirror\disp\enable.c@line: 180 */
/* refer to \mirror\disp\enable.c@line: 181 */
    DISPDBG((0,"DrvCompletePDEV:\n"));
/* refer to \mirror\disp\enable.c@line: 182 */
/* refer to \mirror\disp\enable.c@line: 183 */

/******************************Public*Routine******************************\
* DrvDisablePDEV
*
* Release the resources allocated in DrvEnablePDEV.  If a surface has been
* enabled DrvDisableSurface will have already been called.
*
\**************************************************************************/

/* refer to \mirror\disp\enable.c@line: 193 */
/* refer to \mirror\disp\enable.c@line: 194 */
/* refer to \mirror\disp\enable.c@line: 195 */
/* refer to \mirror\disp\enable.c@line: 196 */
		
	// THINC

	if (ppdev->pEventBlockOnDraw != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventBlockOnDraw);
		ppdev->pfCloseEvent(ppdev->pEventBlockOnDraw);
	}
	if (ppdev->pEventNewCmd != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventNewCmd);
		ppdev->pfCloseEvent(ppdev->pEventNewCmd);
	}
	if (ppdev->pEventRestart != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventRestart);
		ppdev->pfCloseEvent(ppdev->pEventRestart);
	}
	if (ppdev->pEventBlockOnCopy != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventBlockOnCopy);
		ppdev->pfCloseEvent(ppdev->pEventBlockOnCopy);
	}
	if (ppdev->pEventStartBlocking != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventStartBlocking);
		ppdev->pfCloseEvent(ppdev->pEventStartBlocking);
	}
	if (ppdev->pEventStartBlockingCopy != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventStartBlockingCopy);
		ppdev->pfCloseEvent(ppdev->pEventStartBlockingCopy);
	}

	ppdev->pEventBlockOnDraw = NULL;
	ppdev->pEventNewCmd = NULL;
	ppdev->pEventRestart = NULL;
	ppdev->pEventBlockOnCopy = NULL;
	ppdev->pEventStartBlocking = NULL;
	ppdev->pEventStartBlockingCopy = NULL;

	EngUnloadImage(ppdev->hMemDll);
	EngFreeMem(ppdev->pCmdPtrQueue);   
	EngDeletePalette(ppdev->hpalDefault);

	//
	// We don't unmap/delete events here because they are created in user mode server.
	// They are being taken care by EngCreateDriverObj/EngDeleteDriverObj.
	//

	EngFreeMem(dhpdev);
}


/******************************Public*Routine******************************\
* DrvEnableSurface
*
* Enable the surface for the device.  Hook the calls this driver supports.
*
* Return: Handle to the surface if successful, 0 for failure.
*
\**************************************************************************/


/* refer to \mirror\disp\enable.c@line: 212 */
/* refer to \mirror\disp\enable.c@line: 194 */
/* refer to \mirror\disp\enable.c@line: 195 */
/* refer to \mirror\disp\enable.c@line: 215 */
/* refer to \mirror\disp\enable.c@line: 216 */
/* refer to \mirror\disp\enable.c@line: 217 */
/* refer to \mirror\disp\enable.c@line: 218 */
/* refer to \mirror\disp\enable.c@line: 219 */
/* refer to \mirror\disp\enable.c@line: 220 */
/* refer to \mirror\disp\enable.c@line: 221 */
/* refer to \mirror\disp\enable.c@line: 222 */

	HBITMAP hbitmap;

/* refer to \mirror\disp\enable.c@line: 224 */

    DISPDBG((0,"DrvEnableSurface -->\n"));

/* refer to \mirror\disp\enable.c@line: 228 */

/* refer to \mirror\disp\enable.c@line: 230 */
/* refer to \mirror\disp\enable.c@line: 231 */

/* refer to \mirror\disp\enable.c@line: 233 */
/* refer to \mirror\disp\enable.c@line: 234 */

	
/* refer to \mirror\disp\enable.c@line: 236 */
/* refer to \mirror\disp\enable.c@line: 237 */
/* refer to \mirror\disp\enable.c@line: 238 */
/* refer to \mirror\disp\enable.c@line: 239 */
/* refer to \mirror\disp\enable.c@line: 240 */
/* refer to \mirror\disp\enable.c@line: 241 */
/* refer to \mirror\disp\enable.c@line: 242 */
/* refer to \mirror\disp\enable.c@line: 243 */
/* refer to \mirror\disp\enable.c@line: 244 */
/* refer to \mirror\disp\enable.c@line: 245 */
    else if (ppdev->ulBitCount == 32)
    {
/* refer to \mirror\disp\enable.c@line: 248 */
/* refer to \mirror\disp\enable.c@line: 249 */
/* refer to \mirror\disp\enable.c@line: 250 */
 //   else if (ppdev->ulBitCount == 8)
 //   {
 //       ulBitmapType = BMF_8BPP;
 //       flHooks = HOOKS_BMF32BPP;
 //   }
 //   else if (ppdev->ulBitCount == 4)
 //   {
 //       ulBitmapType = BMF_4BPP;
 //       flHooks = HOOKS_BMF32BPP;
 //   }    
	//else if (ppdev->ulBitCount == 1)
 //   {
 //       ulBitmapType = BMF_1BPP;
 //       flHooks = HOOKS_BMF32BPP;
 //   }
	else
	{
		// No other bitmap formats?
		return NULL;
	}

	ppdev->lDeltaScreen = (sizl.cx * ppdev->ulBitCount / 8 + 3);
	ppdev->lDeltaScreen -= ppdev->lDeltaScreen % 4;  

/* refer to \mirror\disp\enable.c@line: 252 */

    mirrorsize = (ULONG)(sizeof(MirrSurf) + ppdev->lDeltaScreen * sizl.cy);
    
    mirrsurf = (MirrSurf *) EngAllocMem(FL_NONPAGED_MEMORY | FL_ZERO_MEMORY,
										// Zero memory is for test only.
										mirrorsize,
                                        0x4D495252);

/* refer to \mirror\disp\enable.c@line: 260 */
		DISPDBG((0, "DrvEnableSurface: failed in EngAllocMem()\n"));
        return(FALSE);
    }
    
/* refer to \mirror\disp\enable.c@line: 288 */
/* refer to \mirror\disp\enable.c@line: 289 */
	mirrsurf->flags = SURF_FG_ONSCREEN;
/* refer to \mirror\disp\enable.c@line: 290 */
/* refer to \mirror\disp\enable.c@line: 291 */
	mirrsurf->ppdev = ppdev;
	mirrsurf->size = mirrsurf->lDelta * mirrsurf->cy;
	//mirrsurf->pListNode = NULL;		// on-screen buffer is not linked to any list
	mirrsurf->id = FRAMEBUFF_ID;		
    
	ppdev->surfList[FRAMEBUFF_ID] = mirrsurf;

/* refer to \mirror\disp\enable.c@line: 266 */

/* refer to \mirror\disp\enable.c@line: 268 */
/* refer to \mirror\disp\enable.c@line: 269 */
/* refer to \mirror\disp\enable.c@line: 270 */

	ppdev->pjScreen = (PVOID)(mirrsurf->pscan);

	if (!EngModifySurface(hsurf, 
						ppdev->hdevEng,
						flHooks,
						0,
						(DHSURF)dhsurf,
						ppdev->pjScreen,
						ppdev->lDeltaScreen,
						NULL))
	{
		EngFreeMem(mirrsurf);
		DISPDBG((0, "DrvEnableSurface: EngModifySurface failed\n"));
		return FALSE;
	}

/* refer to \mirror\disp\enable.c@line: 285 */          

	DISPDBG((0,"DrvEnableSurface: <--.\n"));

    return(hsurf);
}

/******************************Public*Routine******************************\
* DrvDisableSurface
*
* Free resources allocated by DrvEnableSurface.  Release the surface.
*
\**************************************************************************/

/* refer to \mirror\disp\enable.c@line: 304 */
/* refer to \mirror\disp\enable.c@line: 194 */
/* refer to \mirror\disp\enable.c@line: 195 */
/* refer to \mirror\disp\enable.c@line: 196 */

/* refer to \mirror\disp\enable.c@line: 309 */

	//
	//TODO:
	//
	//

	//ppdev->pfSetEvent(ppdev->pEventRestart);

/* refer to \mirror\disp\enable.c@line: 311 */
/* refer to \mirror\disp\enable.c@line: 316 */

static INT NextSurfaceId(PPDEV ppdev)
{
	INT	i = (ppdev->lastOffScreenSurfId >= MAX_OFF_SURF) ? MIN_OFF_SURF : ppdev->lastOffScreenSurfId + 1;
	INT j = i;
	while (ppdev->surfList[i] != NULL)
	{
		i = (i >= MAX_OFF_SURF ? MIN_OFF_SURF : i+1);
		if (i == j)
		{
			RIP("Not enough surface Id");
		}
	}
	ppdev->lastOffScreenSurfId = i;
	return i;
}

/* refer to \mirror\disp\enable.c@line: 528 */
/* refer to \mirror\disp\enable.c@line: 529 */
/* refer to \mirror\disp\enable.c@line: 530 */
/* refer to \mirror\disp\enable.c@line: 531 */
/* refer to \mirror\disp\enable.c@line: 532 */
/* refer to \mirror\disp\enable.c@line: 533 */
/* refer to \mirror\disp\enable.c@line: 534 */
/* refer to \mirror\disp\enable.c@line: 221 */
/* refer to \mirror\disp\enable.c@line: 220 */
/* refer to \mirror\disp\enable.c@line: 222 */
/* refer to \mirror\disp\enable.c@line: 538 */
/* refer to \mirror\disp\enable.c@line: 216 */
	ULONG ulBitCount;

/* refer to \mirror\disp\enable.c@line: 196 */

/* refer to \mirror\disp\enable.c@line: 543 */

	switch (iFormat)
	{
/* refer to \3dlabs\perm2\disp\ddenable.c@line: 44 */	
			ulBitCount = 8;	
			break;
/* refer to \3dlabs\perm2\disp\ddenable.c@line: 50 */	
			ulBitCount = 16;
			break;
/* refer to \3dlabs\perm2\disp\ddenable.c@line: 61 */	
			ulBitCount = 24;
			break;
/* refer to \3dlabs\perm2\disp\ddenable.c@line: 65 */	
			ulBitCount = 32;
			break;
		default:
			// BMF_1BPP, BMF_4BPP, etc.
			return NULL;
	}

/* refer to \mirror\disp\enable.c@line: 550 */
	stride = (sizl.cx*(ulBitCount/8)+3) & ~0x03;
/* refer to \mirror\disp\enable.c@line: 552 */
	   
/* refer to \mirror\disp\enable.c@line: 554 */

	mirrsurf = (MirrSurf *)thincAllocZero(mirrorsize, "DCDB");

	if (!mirrsurf) 
	{
		DISPDBG((0, "DrvCreateDeviceBitmap: failed EngAllocMem\n"));
		return(FALSE);
	}
	                                       
/* refer to \mirror\disp\enable.c@line: 266 */

	hsurf = (HSURF) EngCreateDeviceBitmap(dhsurf, sizl, iFormat);

/* refer to \mirror\disp\enable.c@line: 272 */
/* refer to \mirror\disp\enable.c@line: 273 */
		DISPDBG((0, "DrvCreateDeviceBitmap: failed EngCreateBitmap\n"));
		EngFreeMem(mirrsurf);
		return(FALSE);
	}

   	if (!EngModifySurface(hsurf, 
						ppdev->hdevEng,
						flGlobalHooks,
						0,
						dhsurf,
						mirrsurf->pscan,
						stride,
						NULL))
	{
		DISPDBG((0,"DrvCreateDeviceBitmap: failed EngModifySurface\n"));
		EngFreeMem(mirrsurf);
		EngDeleteSurface(hsurf);
		return NULL;
	}
    
	//
	// Initialize the members in the surface structure
	//
/* refer to \mirror\disp\enable.c@line: 585 */
/* refer to \mirror\disp\enable.c@line: 586 */
/* refer to \mirror\disp\enable.c@line: 587 */
	mirrsurf->ulBitCount = ulBitCount;
	mirrsurf->flags = 0;			
	mirrsurf->ppdev = ppdev;
	mirrsurf->size = stride * sizl.cy;
	mirrsurf->id = NextSurfaceId(ppdev);

	//
	// Store the pointer in the offscreen surface list
	//
	ppdev->surfList[mirrsurf->id] = mirrsurf;

	//
	// Add a command of creating offscreen surface to the queue
	//

	CreateDeviceBitmap(ppdev, mirrsurf);

	//mirrsurf->pCurrentCmdBlock = thincCmdBlockCreate(mirrsurf, NORMAL_CMD_BLOCK_SIZE);
	//if (mirrsurf->pCurrentCmdBlock == NULL)
	//{
	//	DISPDBG((0, "DrvCreateDeviceBitmap() failed in thincCmdBlockCreate()\n"));
 // 		EngFreeMem(mirrsurf);
	//	EngDeleteSurface(hsurf);
	//	return NULL;
/* refer to \3dlabs\perm3\disp\inc\tvp3026.h@line: 455 */

	//
	// Add the surface to the active surface list
	//
	//mirrsurf->pListNode = thincDrvListAdd(ppdev->pListAcitveSurf, mirrsurf);

	//
	// Add it to ToMap list
	//
	//pMemToMap = thincAlloc(sizeof(MemToMap), "THNC");
	//pMemToMap->kernelVirtualAddress = mirrsurf;
	//pMemToMap->pUserVirtualAddress = &(mirrsurf->userVirtualAddress);
	//pMemToMap->pHandle = &(mirrsurf->hShareMem);
	//pMemToMap->size = mirrorsize;
	//pMemToMap->flags = MM_FG_OFF_SURF;
	//
	//thincDrvListAdd(ppdev->pListToMap, pMemToMap);

	//DISPDBG((0, "DrvCreateDeviceBitmap: width = %d, height = %d\n", sizl.cx, sizl.cy));
	return((HBITMAP)hsurf);
}

/* refer to \mirror\disp\enable.c@line: 594 */
/* refer to \mirror\disp\enable.c@line: 595 */
/* refer to \mirror\disp\enable.c@line: 596 */
/* refer to \mirror\disp\enable.c@line: 597 */
/* refer to \mirror\disp\enable.c@line: 221 */

/* refer to \mirror\disp\enable.c@line: 215 */

/* refer to \mirror\disp\enable.c@line: 600 */

/* refer to \mirror\disp\enable.c@line: 602 */

	ppdev = mirrsurf->ppdev;                  

	mirrsurf->flags |= SURF_FG_ZOMBIE;

	//
	// Add this operation to command queue
	//
	DestroyDeviceBitmap(ppdev, mirrsurf->id);

	//
	// Clear the pointer in the off screen surface list
	//
	ppdev->surfList[mirrsurf->id] = NULL;

	// free it
/* refer to \mirror\disp\enable.c@line: 604 */

/* refer to \mirror\disp\enable.c@line: 605 */

/******************************Public*Routine******************************\
* DrvAssertMode
*
* Enable/Disable the given device.
*
\**************************************************************************/

/* refer to \mirror\disp\enable.c@line: 615 */
/* refer to \mirror\disp\enable.c@line: 616 */
/* refer to \mirror\disp\enable.c@line: 617 */
/* refer to \mirror\disp\enable.c@line: 196 */

/* refer to \mirror\disp\enable.c@line: 620 */

/* refer to \mirror\disp\enable.c@line: 622 */

/* refer to \mirror\disp\enable.c@line: 624 */// DrvAssertMode()

BOOL UnMapAndFreeMem(DRIVEROBJ *pDriverObj)
{
	PPDEV ppdev= (PPDEV)pDriverObj->dhpdev;
	PVOID kernelVirtualAddress = ppdev->pfUnMapMem(pDriverObj->pvObj);
	if (kernelVirtualAddress == NULL)
	{
		return FALSE;
	}
	EngFreeMem(kernelVirtualAddress);
	return TRUE;
}

static BOOL bAutoUnmap(DRIVEROBJ *pDriverObj)
{
	PPDEV ppdev= (PPDEV)pDriverObj->dhpdev;
	PVOID kernelVirtualAddress = ppdev->pfUnMapMem(pDriverObj->pvObj);
	if (kernelVirtualAddress == NULL)
	{
		return FALSE;
	}
	return TRUE;
}

static BOOL bServerOffCleanUp(DRIVEROBJ *pDriverObj)
{
	PPDEV ppdev= (PPDEV)pDriverObj->dhpdev;
	ppdev->bServerOn = FALSE;

	if (ppdev->pEventBlockOnDraw != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventBlockOnDraw);
	}
	if (ppdev->pEventNewCmd != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventNewCmd);
	}
	if (ppdev->pEventRestart != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventRestart);
	}
	if (ppdev->pEventBlockOnCopy != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventBlockOnCopy);
	}
	if (ppdev->pEventStartBlocking != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventStartBlocking);
	}
	if (ppdev->pEventStartBlockingCopy != NULL) 
	{
		ppdev->pfSetEvent(ppdev->pEventStartBlockingCopy);
	}
	
	ppdev->pfCloseEvent(ppdev->pEventBlockOnDraw);
	ppdev->pfCloseEvent(ppdev->pEventNewCmd);
	ppdev->pfCloseEvent(ppdev->pEventRestart);
	ppdev->pfCloseEvent(ppdev->pEventBlockOnCopy);
	ppdev->pfCloseEvent(ppdev->pEventStartBlocking);
	ppdev->pfCloseEvent(ppdev->pEventStartBlockingCopy);
	
	ppdev->pEventBlockOnDraw = NULL;
	ppdev->pEventNewCmd = NULL;
	ppdev->pEventRestart = NULL;
	ppdev->pEventBlockOnCopy = NULL;
	ppdev->pEventStartBlocking = NULL;
	ppdev->pEventStartBlockingCopy = NULL;

	return TRUE;
}

static BOOL bCloseSharedEvent(DRIVEROBJ *pDriverObj)
{
	PPDEV ppdev= (PPDEV)pDriverObj->dhpdev;
	

	ppdev->pfCloseEvent(ppdev->pEventBlockOnDraw);
	ppdev->pfCloseEvent(ppdev->pEventNewCmd);
	ppdev->pfCloseEvent(ppdev->pEventRestart);
	
	ppdev->pEventBlockOnDraw = NULL;
	ppdev->pEventNewCmd = NULL;
	ppdev->pEventRestart = NULL;

	return TRUE;
}

static BOOL bUnmapAll(DRIVEROBJ *pDriverObj)
{
	PPDEV ppdev= (PPDEV)pDriverObj->dhpdev;
	
	ppdev->pfCloseEvent(ppdev->pEventBlockOnDraw);
	ppdev->pfCloseEvent(ppdev->pEventNewCmd);
	ppdev->pfCloseEvent(ppdev->pEventRestart);
	ppdev->pfCloseEvent(ppdev->pEventBlockOnCopy);
	ppdev->pfCloseEvent(ppdev->pEventStartBlocking);
	ppdev->pfCloseEvent(ppdev->pEventStartBlockingCopy);
	
	ppdev->pEventBlockOnDraw = NULL;
	ppdev->pEventNewCmd = NULL;
	ppdev->pEventRestart = NULL;
	ppdev->pEventBlockOnCopy = NULL;
	ppdev->pEventStartBlocking = NULL;
	ppdev->pEventStartBlockingCopy = NULL;

	return TRUE;
}

/******************************Public*Routine******************************\
* DrvEscape
*
* Accepting the command from user .
*
\**************************************************************************/
ULONG
  DrvEscape(
    IN SURFOBJ  *pso,
    IN ULONG  iEsc,
    IN ULONG  cjIn,
    IN PVOID  pvIn,
    IN ULONG  cjOut,
    OUT PVOID  pvOut)
{
	INT		i;
	PPDEV	ppdev = PPDEV_OF_PSURFOBJ(pso);

	DISPDBG((0,"DrvEscape:\n"));
	switch (iEsc) {
		case GESC_SERVER_START:	
		{
			PVOID*			pUserMem = (PVOID*)pvOut;
			PPDEV			ppdev;
			PMirrSurf		psurf;
			INT				len, size;
			PThincDrvNode	pNode;	
			HANDLE			hMapCmdQueue;
			mirror_cursor*	mc;
			PMapToUserMode	pMapToUserMode;
			PVOID			userVirtualAddress;
			PVOID			hSharedMem;

			if (pvIn != NULL)
			{
				recheckInterval = ((PParaIn)pvIn)->recheckInterval;
				maxCount = 3000000000/recheckInterval;
			}

			psurf = (PMirrSurf)(pso->dhsurf);
/* refer to \3dlabs\perm2\disp\heap.c@line: 1002 */

			//
			// Let GDI take care of the exist of the server
			//
			// FIXME:
			EngCreateDriverObj(NULL, bServerOffCleanUp, ppdev->hdevEng);

			//
			// Map memory and copy the user mode address back
			//
			pMapToUserMode = (PMapToUserMode)pvOut;

			//
			//  Mapping the onscreen surface. pso is pointing to the framebuffer.
			// 
			if (ppdev->pfMapMem(&psurf->userVirtualAddress,
								(PCHAR)psurf + sizeof(MirrSurf),
								&psurf->hShareMem,
								psurf->size) == NULL)
			{
				DISPDBG((0, " DrvEscape: Cannot map onscreen surface\n"));
				return -1;
			}
			// Let GDI take care of the unmapping when server exists;
			EngCreateDriverObj(psurf->hShareMem, bAutoUnmap, ppdev->hdevEng);
			
			pMapToUserMode->MapToUserList[0].userVirtualAddress = psurf->userVirtualAddress;
			pMapToUserMode->MapToUserList[0].flags = MM_FG_ON_SURF;		
                           
			//
			// Re-initialize and map the command queue.
			//                
			thincInitCmdQueue(ppdev->pCmdPtrQueue);

			size = sizeof(ThincCmdPtrQueue)
				+ sizeof(ThincCmdPtr) * ppdev->pCmdPtrQueue->cmdQueueSize;

			if (ppdev->pfMapMem(&(ppdev->pCmdPtrQueue->userVirtualAddress),
								ppdev->pCmdPtrQueue,
								&(ppdev->pCmdPtrQueue->hSharedMem),
								size) == NULL)
			{
				DISPDBG((0, " DrvEscape: Cannot map command queue\n"));
				return -1;
			}

			// Let GDI take care of the unmapping when server exists;
			EngCreateDriverObj(ppdev->pCmdPtrQueue->hSharedMem, bAutoUnmap, ppdev->hdevEng);
			
			pMapToUserMode->MapToUserList[1].userVirtualAddress 
				= ppdev->pCmdPtrQueue->userVirtualAddress;
			pMapToUserMode->MapToUserList[1].flags = MM_FG_CMD_QUE;		


			//
			// Re-initialize and map the command block
			//

			thincCmdBlockInit(ppdev->pCmdBlock);

			size = sizeof(ThincCmdBlock) + ppdev->pCmdBlock->blockSize;

			if (ppdev->pfMapMem(&(ppdev->pCmdBlock->userVirtualAddress),
								ppdev->pCmdBlock,
								&(ppdev->pCmdBlock->hMappingHandle),
								size) == NULL)
			{
				DISPDBG((0, " DrvEscape: Cannot map command block\n"));
				return -1;
			}

			// Let GDI take care of the unmapping when server exists;
			EngCreateDriverObj(ppdev->pCmdBlock->hMappingHandle, bAutoUnmap, ppdev->hdevEng);

			pMapToUserMode->MapToUserList[2].userVirtualAddress 
				= ppdev->pCmdBlock->userVirtualAddress;
			pMapToUserMode->MapToUserList[2].flags = MM_FG_CMD_BLK;		

			//
			// Map the shared signals
			//
			size = sizeof(ThincSignals);

			if (ppdev->pfMapMem(&(userVirtualAddress),
								&(ppdev->thincSignals),
								&(hSharedMem),
								size) == NULL)
			{
				DISPDBG((0, " DrvEscape: Cannot map thincSignals\n"));
				return -1;
			}
			// Let GDI take care of the unmapping when server exists;
			EngCreateDriverObj(hSharedMem, bAutoUnmap, ppdev->hdevEng);

			pMapToUserMode->MapToUserList[3].userVirtualAddress = userVirtualAddress;
			pMapToUserMode->MapToUserList[3].flags = MM_FG_SIGNAL;		

			// Clear signals
			ppdev->thincSignals.bReqBlockDrawing = FALSE;
			ppdev->thincSignals.bStatusBlockBeforeCopy = FALSE;
			ppdev->thincSignals.bStatusDrawing = FALSE;
			ppdev->thincSignals.bStatusWaitingForDrawingFinishes = FALSE;
			ppdev->thincSignals.bReqNewCommandSignal = TRUE;

			// Set all events
			ppdev->pEventBlockOnCopy = ppdev->pfOpenEvent(enBlockOnCopy);
			ppdev->pEventBlockOnDraw = ppdev->pfOpenEvent(enBlockOnDraw);
			ppdev->pEventNewCmd = ppdev->pfOpenEvent(enNewCmd);
			ppdev->pEventRestart = ppdev->pfOpenEvent(enRestart);
			ppdev->pEventStartBlocking = ppdev->pfOpenEvent(enStartBlocking);
			ppdev->pEventStartBlockingCopy = ppdev->pfOpenEvent(enStartBlockingCopy);

			//ppdev->pfSetEvent(ppdev->pEventBlockOnCopy);
			//ppdev->pfSetEvent(ppdev->pEventBlockOnDraw);
			//ppdev->pfSetEvent(ppdev->pEventNewCmd);
			//ppdev->pfSetEvent(ppdev->pEventRestart);
			//ppdev->pfSetEvent(ppdev->pEventStartBlocking);
			//ppdev->pfSetEvent(ppdev->pEventStartBlockingCopy);

			//
			//
			//
			len = 4;
			pMapToUserMode->len = 4;

			//
			// Copy the cursor information
			//
			mc = (mirror_cursor*)((PCHAR)pvOut + sizeof(MapToUserMode));

			if (ppdev->drvManagedCursor)
			{
				PVOID cursormask = ((PCHAR)mc) + sizeof(mirror_cursor);

				DISPDBG((0, " DrvEscape: drvManagedCursor == true\n"));
				mc->cursorHeight = ppdev->cursorHeight;
				mc->cursorWidth = ppdev->cursorWidth;
				mc->cursorSize = ppdev->cursorSize;
				mc->xHot = ppdev->xHot;
				mc->yHot = ppdev->yHot;

				memcpy(cursormask, ppdev->cursorMask, mc->cursorSize);

				DISPDBG((0, " DrvEscape: mc is pointing to %d.\n", (int)mc));

				DISPDBG((0, " DrvEscape: cursor_pdev(Height=%d, Width=%d, Size=%d, xHot=%d, yHot=%d)\n",
					ppdev->cursorHeight, ppdev->cursorWidth, ppdev->cursorSize,
					ppdev->xHot, ppdev->yHot));

				DISPDBG((0, " DrvEscape: cursor_mc  (Height=%d, Width=%d, Size=%d, xHot=%d, yHot=%d)\n",
					mc->cursorHeight, mc->cursorWidth, mc->cursorSize,
					mc->xHot, mc->yHot));
			}
			else
			{
				mc->cursorSize = -1;
			}

			//
			// Add CreateDeviceBitmap commands for each existed off-screen surface
			//
			// FakeRawUpdate(psurf);						//onscreen surface
			for (i = 1; i < MAX_OFF_SURF; i++)
			{
				if (ppdev->surfList[i] != NULL)
				{
					CreateDeviceBitmap(ppdev, ppdev->surfList[i]);
					if (i != FRAMEBUFF_ID)
					{
						FakeRawUpdate(ppdev->surfList[i]);	//offscreen surface 
					}
				}
			}

			//
			// set the flag indicating the server has started running. Then we can start queuing 
			// commands
			//
			ppdev->bServerOn = TRUE;

			return iEsc;
		}
		case GESC_RECREATE_FB:
		{
			//
			// TODO: That's another story. 
			//
			return iEsc;
		}
	}
/* refer to \mirror\app\main.cxx@line: 126 */
/* refer to \mirror\app\main.cxx@line: 127 */


//void BlockOnRequest(SURFOBJ* surfobj1, SURFOBJ* surfobj2)
//{		
//	do{
//		PPDEV ppdev = PPDEV_OF_PSURFOBJ(surfobj1);		
//		PMirrSurf psurfDst = (PMirrSurf)surfobj1->dhsurf;
//		
//		if (ppdev != NULL && psurfDst != NULL && psurfDst->id != FRAMEBUFF_ID)
//		{
//			// only block onscreen drawing
//			break;
//		}
//
//		if (ppdev == NULL)								
//		{												
//			if (surfobj2 == NULL)						
//				break;									
//			ppdev = PPDEV_OF_PSURFOBJ(surfobj2);		
//			if (ppdev == NULL)							
//				break;									
//		}												
//		/*DISPDBG((0, "BlockOnRequest -->\n"));*/		
//		/*ASSERT((ppdev != NULL), "BlockOnRequest: ppdev == NULL\n");*/	
//		if (ppdev->thincSignals.bReqBlockDrawing)
//		{												
//			//LARGE_INTEGER timeout;						
//
//			// Notify the user mode server that we are going to block
//			ppdev->pfSetEvent(ppdev->pEventStartBlocking);
//			//DISPDBG((0, "BlockOnRequest: pSharedEvent != NULL\n"));			
//			//timeout.QuadPart = -TIME_OUT;				
////			ppdev->pfWaitOnEvent(ppdev->pSharedEvent, &timeout);	
//			ppdev->pfWaitOnEvent(ppdev->pEventBlockOnDraw, NULL);	
//		}												
//		/*DISPDBG((0, "BlockOnRequest <--\n"));	*/		
//	}while(FALSE);
//}
//
//void BlockBeforeCopy(PPDEV ppdev, SURFOBJ* surfobj1, SURFOBJ* surfobj2)
//{		
//	do{
//		if (ppdev == NULL)
//		{
//			ppdev = PPDEV_OF_PSURFOBJ(surfobj1);		
//			if (ppdev == NULL)								
//			{												
//				if (surfobj2 == NULL)						
//					break;									
//				ppdev = PPDEV_OF_PSURFOBJ(surfobj2);		
//				if (ppdev == NULL)							
//					break;									
//			}			
//		}
//		ppdev->thincSignals.bStatusBlockBeforeCopy = TRUE;
//		ppdev->pfResetEvent(ppdev->pEventBlockOnCopy);
//		ppdev->pfSetEvent(ppdev->pEventStartBlockingCopy);
//		ppdev->pfWaitOnEvent(ppdev->pEventBlockOnCopy, NULL);
//	}while (FALSE);
//}
//
