/******************************Module*Header*******************************\
*
*                           *******************
*                           * GDI SAMPLE CODE *
*                           *******************
*
* Module Name: screen.c
*
* Initializes the GDIINFO and DEVINFO structures for DrvEnablePDEV.
*
* Copyright (c) 1992-1998 Microsoft Corporation
\**************************************************************************/

#include "driver.h"

/* refer to \mirror\disp\screen.c@line: 16 */
/* refer to \mirror\disp\screen.c@line: 17 */
/* refer to \mirror\disp\screen.c@line: 18 */

/* refer to \mirror\disp\screen.c@line: 20 */
/* refer to \mirror\disp\screen.c@line: 21 */

/* refer to \mirror\disp\screen.c@line: 23 */
/* refer to \mirror\disp\screen.c@line: 24 */
/* refer to \mirror\disp\screen.c@line: 25 */
                   ), /* Graphics capabilities         */
    SYSTM_LOGFONT,    /* Default font description */
    HELVE_LOGFONT,    /* ANSI variable font description   */
    COURI_LOGFONT,    /* ANSI fixed font description          */
    0,                /* Count of device fonts          */
    0,                /* Preferred DIB format          */
    8,                /* Width of color dither          */
    8,                /* Height of color dither   */
    0                 /* Default palette to use for this device */
};

// This is default palette from Win 3.1

#define NUMPALCOLORS 256
#define NUMPALRESERVED 20

ULONG palColors[NUMPALCOLORS][4] =
{
    { 0,   0,   0,   0  },  // 0
    { 0x80,0,   0,   0  },  // 1
    { 0,   0x80,0,   0  },  // 2
    { 0x80,0x80,0,   0  },  // 3
    { 0,   0,   0x80,0  },  // 4
    { 0x80,0,   0x80,0  },  // 5
    { 0,   0x80,0x80,0  },  // 6
    { 0xC0,0xC0,0xC0,0  },  // 7

    { 192, 220, 192, 0  },  // 8
    { 166, 202, 240, 0  },  // 9
    { 255, 251, 240, 0  },  // 10
    { 160, 160, 164, 0  },  // 11

    { 0x80,0x80,0x80,0  },  // 12
    { 0xFF,0,   0,   0  },  // 13
    { 0,   0xFF,0,   0  },  // 14
    { 0xFF,0xFF,0,   0  },  // 15
    { 0,   0,   0xFF,0  },  // 16
    { 0xFF,0,   0xFF,0  },  // 17
    { 0,   0xFF,0xFF,0  },  // 18
    { 0xFF,0xFF,0xFF,0  }   // 19
};

/******************************Public*Routine******************************\
* bInitPDEV
*
* Determine the mode we should be in based on the DEVMODE passed in.
* For mirrored devices we don't bother querying the miniport.
*
\**************************************************************************/

/* refer to \mirror\disp\screen.c@line: 76 */
/* refer to \mirror\disp\screen.c@line: 77 */
/* refer to \mirror\disp\screen.c@line: 78 */
/* refer to \mirror\disp\screen.c@line: 79 */
/* refer to \mirror\disp\screen.c@line: 80 */
/* refer to \mirror\disp\screen.c@line: 81 */
/* refer to \mirror\disp\screen.c@line: 82 */
/* refer to \mirror\disp\screen.c@line: 83 */
/* refer to \mirror\disp\screen.c@line: 84 */
/* refer to \mirror\disp\screen.c@line: 85 */
/* refer to \mirror\disp\screen.c@line: 86 */
/* refer to \mirror\disp\screen.c@line: 87 */
/* refer to \mirror\disp\screen.c@line: 88 */
/* refer to \mirror\disp\screen.c@line: 89 */

    //
/* refer to \mirror\disp\screen.c@line: 92 */
/* refer to \mirror\disp\screen.c@line: 93 */
    //
    
/* refer to \mirror\disp\screen.c@line: 96 */
/* refer to \mirror\disp\screen.c@line: 97 */
/* refer to \mirror\disp\screen.c@line: 98 */
/* refer to \mirror\disp\screen.c@line: 99 */
/* refer to \mirror\disp\screen.c@line: 100 */
    
/* refer to \mirror\disp\screen.c@line: 102 */
/* refer to \mirror\disp\screen.c@line: 103 */
/* refer to \mirror\disp\screen.c@line: 104 */
    
/* refer to \mirror\disp\screen.c@line: 106 */
/* refer to \mirror\disp\screen.c@line: 107 */
/* refer to \mirror\disp\screen.c@line: 108 */
/* refer to \mirror\disp\screen.c@line: 109 */

/* refer to \mirror\disp\screen.c@line: 111 */
/* refer to \mirror\disp\screen.c@line: 112 */
/* refer to \mirror\disp\screen.c@line: 113 */
/* refer to \mirror\disp\screen.c@line: 114 */
/* refer to \mirror\disp\screen.c@line: 115 */
/* refer to \mirror\disp\screen.c@line: 116 */ 
/* refer to \mirror\disp\screen.c@line: 117 */       // not used
/* refer to \mirror\disp\screen.c@line: 118 */     // We don't have accelerated screen-
/* refer to \mirror\disp\screen.c@line: 119 */
/* refer to \mirror\disp\screen.c@line: 120 */

/* refer to \mirror\disp\screen.c@line: 122 */
/* refer to \mirror\disp\screen.c@line: 123 */

/* refer to \mirror\disp\screen.c@line: 125 */

/* refer to \mirror\disp\screen.c@line: 127 */           // flRaster is reserved by DDI

/* refer to \mirror\disp\screen.c@line: 129 */
/* refer to \mirror\disp\screen.c@line: 130 */
/* refer to \mirror\disp\screen.c@line: 131 */

/* refer to \mirror\disp\screen.c@line: 133 */    // One-to-one aspect ratio
/* refer to \mirror\disp\screen.c@line: 134 */
/* refer to \mirror\disp\screen.c@line: 135 */

/* refer to \mirror\disp\screen.c@line: 137 */       // A style unit is 3 pels
/* refer to \mirror\disp\screen.c@line: 138 */
/* refer to \mirror\disp\screen.c@line: 139 */

/* refer to \mirror\disp\screen.c@line: 141 */
/* refer to \mirror\disp\screen.c@line: 142 */
/* refer to \mirror\disp\screen.c@line: 143 */
/* refer to \mirror\disp\screen.c@line: 144 */

/* refer to \mirror\disp\screen.c@line: 146 */

/* refer to \mirror\disp\screen.c@line: 148 */
/* refer to \mirror\disp\screen.c@line: 149 */
/* refer to \mirror\disp\screen.c@line: 150 */
/* refer to \mirror\disp\screen.c@line: 151 */
/* refer to \mirror\disp\screen.c@line: 152 */
/* refer to \mirror\disp\screen.c@line: 153 */
/* refer to \mirror\disp\screen.c@line: 154 */
/* refer to \mirror\disp\screen.c@line: 155 */
/* refer to \mirror\disp\screen.c@line: 156 */
/* refer to \mirror\disp\screen.c@line: 157 */
/* refer to \mirror\disp\screen.c@line: 158 */
/* refer to \mirror\disp\screen.c@line: 159 */

/* refer to \mirror\disp\screen.c@line: 161 */
/* refer to \mirror\disp\screen.c@line: 162 */
/* refer to \mirror\disp\screen.c@line: 163 */

/* refer to \mirror\disp\screen.c@line: 165 */
/* refer to \mirror\disp\screen.c@line: 166 */
/* refer to \mirror\disp\screen.c@line: 166 */
/* refer to \mirror\disp\screen.c@line: 168 */
/* refer to \mirror\disp\screen.c@line: 169 */
/* refer to \mirror\disp\screen.c@line: 169 */
/* refer to \mirror\disp\screen.c@line: 171 */
/* refer to \mirror\disp\screen.c@line: 172 */
/* refer to \mirror\disp\screen.c@line: 172 */

/* refer to \mirror\disp\screen.c@line: 175 */

/* refer to \mirror\disp\screen.c@line: 177 */
/* refer to \mirror\disp\screen.c@line: 178 */
/* refer to \mirror\disp\screen.c@line: 179 */
/* refer to \mirror\disp\screen.c@line: 180 */
/* refer to \mirror\disp\screen.c@line: 181 */
/* refer to \mirror\disp\screen.c@line: 182 */

/* refer to \mirror\disp\screen.c@line: 184 */   // For printers only
/* refer to \mirror\disp\screen.c@line: 185 */

/* refer to \mirror\disp\screen.c@line: 187 */
/* refer to \mirror\disp\screen.c@line: 188 */

/* refer to \mirror\disp\screen.c@line: 190 */

/* refer to \mirror\disp\screen.c@line: 192 */

/* refer to \mirror\disp\screen.c@line: 194 */

/* refer to \mirror\disp\screen.c@line: 196 */

/* refer to \mirror\disp\screen.c@line: 198 */

/* refer to \mirror\disp\screen.c@line: 200 */
/* refer to \mirror\disp\screen.c@line: 201 */
/* refer to \mirror\disp\screen.c@line: 202 */

/* refer to \mirror\disp\screen.c@line: 204 */
/* refer to \mirror\disp\screen.c@line: 205 */

/* refer to \mirror\disp\screen.c@line: 207 */

/* refer to \mirror\disp\screen.c@line: 209 */
/* refer to \mirror\disp\screen.c@line: 210 */

/* refer to \mirror\disp\screen.c@line: 212 */

/* refer to \mirror\disp\screen.c@line: 214 */
/* refer to \mirror\disp\screen.c@line: 215 */
/* refer to \mirror\disp\screen.c@line: 216 */
/* refer to \mirror\disp\screen.c@line: 217 */
/* refer to \mirror\disp\screen.c@line: 218 */
/* refer to \mirror\disp\screen.c@line: 219 */

/* refer to \mirror\disp\screen.c@line: 221 */
/* refer to \mirror\disp\screen.c@line: 222 */
/* refer to \mirror\disp\screen.c@line: 223 */
/* refer to \mirror\disp\screen.c@line: 224 */
/* refer to \mirror\disp\screen.c@line: 225 */
/* refer to \mirror\disp\screen.c@line: 226 */
/* refer to \mirror\disp\screen.c@line: 227 */
/* refer to \mirror\disp\screen.c@line: 228 */
/* refer to \mirror\disp\screen.c@line: 229 */
/* refer to \mirror\disp\screen.c@line: 230 */
/* refer to \mirror\disp\screen.c@line: 231 */
/* refer to \mirror\disp\screen.c@line: 232 */
/* refer to \mirror\disp\screen.c@line: 233 */
/* refer to \mirror\disp\screen.c@line: 234 */
/* refer to \mirror\disp\screen.c@line: 235 */
/* refer to \mirror\disp\screen.c@line: 236 */

/* refer to \mirror\disp\screen.c@line: 238 */
/* refer to \mirror\disp\screen.c@line: 239 */

/* refer to \mirror\disp\screen.c@line: 241 */
    
/* refer to \mirror\disp\screen.c@line: 243 */
/* refer to \mirror\disp\screen.c@line: 244 */
/* refer to \mirror\disp\screen.c@line: 245 */
/* refer to \mirror\disp\screen.c@line: 246 */
/* refer to \mirror\disp\screen.c@line: 247 */

/* refer to \mirror\disp\screen.c@line: 249 */
/* refer to \mirror\disp\screen.c@line: 250 */
/* refer to \mirror\disp\screen.c@line: 251 */
/* refer to \mirror\disp\screen.c@line: 252 */

/* refer to \mirror\disp\screen.c@line: 200 */
/* refer to \mirror\disp\screen.c@line: 201 */
/* refer to \mirror\disp\screen.c@line: 256 */
       
/* refer to \mirror\disp\screen.c@line: 258 */
/* refer to \mirror\disp\screen.c@line: 259 */     // cColors
/* refer to \mirror\disp\screen.c@line: 260 */       // pulColors
/* refer to \mirror\disp\screen.c@line: 261 */
/* refer to \mirror\disp\screen.c@line: 262 */
/* refer to \mirror\disp\screen.c@line: 263 */         // flRed, flGreen, flBlue [not used]
/* refer to \mirror\disp\screen.c@line: 264 */
/* refer to \mirror\disp\screen.c@line: 265 */
/* refer to \mirror\disp\screen.c@line: 266 */
/* refer to \mirror\disp\screen.c@line: 256 */
                EngCreatePalette(PAL_BGR, 0,NULL,
                                 0,0,0);
                //EngCreatePalette(PAL_BITFIELDS, 0,NULL,
                //                 ppdev->flRed,ppdev->flGreen,ppdev->flBlue);
    }

    
    
    return(TRUE);
}



