/* Copyright 2004, 2005 Lei Zhang, Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/******************************Module*Header*******************************\
*
*                           *********************
*                           * THINC header file *
*                           *********************
*
* Module Name: thincDrvList.h
*
* This module contains the functions that are related with THINC 
*
***************************************************************************/

#ifndef _THINC_DRV_LIST_
#define _THINC_DRV_LIST_


#include <stdarg.h>
#include "windef.h"
#include "wingdi.h"
#include "winddi.h"

typedef struct ThincDrvNode_s{
	struct ThincDrvNode_s* next;
	struct ThincDrvNode_s* prev;
	PVOID element;
} ThincDrvNode, *PThincDrvNode, ThincDrvList, *PThincDrvList;

//typedef struct thincDrvList_s{
//	int len;
//	struct ThincDrvNode_s* first;
//	struct ThincDrvNode_s* last;
//} thincDrvList, *PthincDrvList;

typedef void (*FreeMem)(void* mem);

// Create the first node of the double link.
// Note that this node will always be empty.
PThincDrvNode thincDrvListCreate();

PVOID thincDrvListReadFirstNode(PThincDrvNode pList);	// list is the header node

PVOID thincDrvListReadAndDeleteFirstNode(PThincDrvNode pList);

PThincDrvNode thincDrvListAdd(PThincDrvNode pList, PVOID data);

BOOL thincDrvListRemove(PThincDrvNode pNode);

BOOL thincDrvListDestroy(PThincDrvNode pList, FreeMem pfFreeMem);

#endif /* _THINC_DRV_LIST_ */
