/******************************Module*Header*******************************\
*
*                           *******************
*                           * GDI SAMPLE CODE *
*                           *******************
*
* Module Name: driver.h
*
* contains prototypes for the frame buffer driver.
*
* Copyright (c) 1992-1998 Microsoft Corporation
\**************************************************************************/

#ifndef __UTILS__
#define __UTILS__
#include "driver.h"
extern int recheckInterval;
extern int maxCount;

#define PPDEV_OF_PSURFOBJ(surf) ((PPDEV)((surf)->dhpdev))
#define MKTAG(STR) (*(ULONG*)(&(STR)))

#define	SWAP_RED_BLUE(x)\
		do {							\
			char* q1 = ((char*)&x);		\
			char* q2 = q1+2;			\
			char  q3;					\
			q3 = *q1;					\
			*q1 = *q2;					\
			*q2 = q3;					\
		} while (FALSE);	

#define ASSERT(x,y) if(!x)RIP(y)
//#define TIME_OUT	NULL
#define TIME_OUT	50000000

//#define min(x,y) ((x<y)?x:y)
//#define max(x,y) ((x>y)?x:y)
//

//#define BlockOnRequest(surfobj1, surfobj2)\
//	do {							\
//		PPDEV ppdev = PPDEV_OF_PSURFOBJ(surfobj1);		\
//		if (ppdev == NULL)								\
//		{												\
//			if (surfobj2 == NULL)						\
//				break;									\
//			ppdev = PPDEV_OF_PSURFOBJ(surfobj2);		\
//			if (ppdev == NULL)							\
//				break;									\
//		}												\
//		/*DISPDBG((0, "BlockOnRequest -->\n"));*/			\
//		/*ASSERT((ppdev != NULL), "BlockOnRequest: ppdev == NULL\n");*/	\
//		if (ppdev->pSharedEvent != NULL)				\
//		{												\
//			LARGE_INTEGER timeout;						\
//			DISPDBG((0, "BlockOnRequest: pSharedEvent != NULL\n"));			\
//			timeout.QuadPart = -TIME_OUT;				\
//			ppdev->pfWaitOnEvent(ppdev->pSharedEvent, &timeout);	\
//		}												\
//		/*DISPDBG((0, "BlockOnRequest <--\n"));	*/		\
//	} while(FALSE);
#if 1
#define START_DRAWING												\
	do {															\
		LARGE_INTEGER timeout;										\
		int counter = 0;											\
		if (ppdev == NULL)											\
		{															\
			break;													\
		}															\
		else														\
		{															\
			if (ppdev->iCallStackDepth++ > 0)						\
			{														\
				DISPDBG((0, "%s::iCallStackDepth = %d \n", __FUNCTION__, ppdev->iCallStackDepth));\
				break;												\
			}														\
		}															\
		if (!ppdev->bServerOn || ppdev->pEventBlockOnDraw == NULL)	\
		{															\
			break;													\
		}															\
		timeout.QuadPart = -recheckInterval;						\
		while (ppdev->pfAtomicCompareExchange(&(ppdev->thincSignals.bStatusDrawing),TRUE,FALSE))		\
		{															\
			if (counter++ > maxCount) break;						\
			TimeStamp(ppdev, TIME_STAMP_BEFORE_WAIT, __FUNCTION__);	\
			ppdev->pfWaitOnEvent(ppdev->pEventBlockOnDraw, &timeout);	\
			TimeStamp(ppdev, TIME_STAMP_AFTER_WAIT, __FUNCTION__);	\
		}															\
	} while(FALSE);

#define FINISH_DRAWING												\
	do {															\
		if (ppdev != NULL)											\
		{															\
			if ((--ppdev->iCallStackDepth) == 0)                    \
			   ppdev->thincSignals.bStatusDrawing = FALSE;			\
		}															\
	}while (FALSE);
#else
#define START_DRAWING												\
	do {															\
		LARGE_INTEGER timeout;										\
		if (ppdev == NULL || ppdev->pEventBlockOnDraw == NULL)		\
		{															\
			break;													\
		}															\
		if (ppdev->thincSignals.bReqBlockDrawing)						\
		{																\
			/* Notify the user mode server that we are going to block*/	\
			LARGE_INTEGER timeout;									    \
			/*DISPDBG((0, "BlockOnRequest: pSharedEvent != NULL\n"));*/ \
			timeout.QuadPart = -TIME_OUT;								\
			ppdev->pfWaitOnEvent(ppdev->pEventBlockOnDraw, /*NULL*/&timeout);		\
		}																\
		ppdev->thincSignals.bStatusDrawing = TRUE;		\
	} while(FALSE);
		//timeout.QuadPart = -TIME_OUT;								\
		//ppdev->pfWaitOnEvent(ppdev->pEventBlockOnDraw, &timeout);	\

//LARGE_INTEGER timeout;						
//timeout.QuadPart = -TIME_OUT;				
//ppdev->pfWaitOnEvent(ppdev->pSharedEvent, &timeout);	


#define FINISH_DRAWING												\
	do {															\
		if (ppdev == NULL || ppdev->pEventBlockOnDraw == NULL)		\
		{															\
			break;													\
		}															\
		/*if (ppdev->thincSignals.bReqBlockDrawing)					\
		{															\
			ppdev->pfSetEvent(ppdev->pEventStartBlocking);			\
		}*/															\
		ppdev->thincSignals.bStatusDrawing = FALSE;				\
		/*ppdev->pfSetEvent(ppdev->pEventBlockOnDraw);*/				\
	}while (FALSE);
#endif 
#endif