/* Copyright 2004, 2005 Lei Zhang, Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/******************************Module*Header*******************************\
*
*                           *********************
*                           * THINC heder file  *
*                           *********************
*
* Module Name: mem.h
*
* contains the definition of the loadable kernel dll. It includes the routines
* for event sharing, memory sharing between kernel mode and user mode. These 
* definition are used by mirror the mirror driver.
*
***************************************************************************/

typedef PVOID (*PFCreateMem) (	IN OUT PVOID* pUserVirtualAddress,
								IN OUT PVOID* pKernelVirtualAddress,
								IN OUT PVOID* ppMemBlockInfo,
								IN     SIZE_T	buffersize);

typedef PVOID (*PFDeAllocMem) (IN OUT PVOID pMemBlockInfo);

typedef PVOID (*PFMapMem) ( IN OUT PVOID* pUserVirtualAddress,
							IN     PVOID  kernelVirtualAddress,
							IN OUT PVOID* ppMemoryBlockInfo,
							IN     SIZE_T buffersize);
	   
typedef PVOID (*PFUnMapMem)	(IN OUT PVOID pMemoryBlockInfo);

typedef PVOID (*PFOpenEvent)(IN PCWSTR eventName);

typedef VOID (*PFCloseEvent)(IN PVOID pEvent);

typedef VOID (*PFWaitOnEvent)(IN PVOID pEvent,
							  IN PLARGE_INTEGER  Timeout);
typedef LONG (*PFSetEvent) (IN PVOID pEvent);

typedef LONG (*PFResetEvent)(IN PVOID pEvent);

typedef LONG (*PFAtomicCompareExchange)(IN OUT PLONG  Destination,
										IN LONG  Exchange,
										IN LONG  Comparand);
typedef VOID (*PFQuerySystemTime) (OUT PVOID pTime);

EXTERN_C DECLSPEC_IMPORT PFCreateMem	CreateMem;
EXTERN_C DECLSPEC_IMPORT PFDeAllocMem	DeAllocMem;
EXTERN_C DECLSPEC_IMPORT PFMapMem		MapMem;
EXTERN_C DECLSPEC_IMPORT PFUnMapMem		UnMapmem;
EXTERN_C DECLSPEC_IMPORT PFOpenEvent	OpenAndSetSharedEvent;
EXTERN_C DECLSPEC_IMPORT PFCloseEvent	CloseSharedEvent;
EXTERN_C DECLSPEC_IMPORT PFWaitOnEvent	WaitOnSharedEvent;
EXTERN_C DECLSPEC_IMPORT PFSetEvent		SetSharedEvent;
EXTERN_C DECLSPEC_IMPORT PFResetEvent	ResetSharedEvent;
EXTERN_C DECLSPEC_IMPORT PFAtomicCompareExchange	AtomicCompareExchange;
EXTERN_C DECLSPEC_IMPORT PFQuerySystemTime QuerySystemTime;
